
local dataObj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("Broker_BattleRes", {
	type = "data source",
	icon = "Interface\\Icons\\spell_nature_reincarnation",
	label = "BattleRes",
	text = "0",
})

local frame = CreateFrame("Frame")
frame:Hide()

local total = 0
frame:SetScript("OnUpdate", function(self, elapsed)
	total = total + elapsed
	if total > 0.3 then
		total = 0

		local charges, _, started, duration = GetSpellCharges(20484) -- Rebirth
		if not charges then
			self:Hide()
			dataObj.text = "0"
			frame:RegisterEvent("SPELL_UPDATE_CHARGES")
			return
		end

		local time = duration - (GetTime() - started)
		local m = floor(time / 60)
		local s = mod(time, 60)

		dataObj.text = ("%d (%02d:%02d)"):format(charges, m, s)
	end
end)

function frame:SPELL_UPDATE_CHARGES()
	local charges = GetSpellCharges(20484) -- Rebirth
	if charges then
		self:UnregisterEvent("SPELL_UPDATE_CHARGES")
		dataObj.text = "0"
		self:Show()
	end
end

function frame:ZONE_CHANGED_NEW_AREA()
	self:UnregisterEvent("SPELL_UPDATE_CHARGES")
	self:Hide()
	dataObj.text = "0"

	local _, type = IsInInstance()
	if type == "raid" then
		frame:RegisterEvent("SPELL_UPDATE_CHARGES")
	end
end
frame.PLAYER_LOGIN = frame.ZONE_CHANGED_NEW_AREA

frame:SetScript("OnEvent", function(self, event, ...)
	self[event](self, ...)
end)
frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
frame:RegisterEvent("PLAYER_LOGIN")

